*******************************************************************************
* PROGRAMA: Demo ON PAINT event
* LENGUAJE: HMG
* FECHA:    Setiembre 2012
* AUTOR:    Dr. CLAUDIO SOTO
* PAIS:     URUGUAY
* E-MAIL:   srvet@adinet.com.uy
* BLOG:     http://srvet.blogspot.com
*******************************************************************************


#include "hmg.ch"
#include "hfcl.ch"


FUNCTION MAIN

   PRIVATE hBitmap := 0 

   DEFINE WINDOW Win1;
            AT 0,0;
            WIDTH  760;
            HEIGHT 480;
            TITLE "Bos Taurus: Save Drawn Image Demo";
            MAIN;
            ICON "BT_Icon" ;
            ON INIT     Proc_ON_INIT ();
            ON RELEASE  Proc_ON_RELEASE ();
            ON PAINT    Proc_ON_PAINT ()
            
      ON KEY ESCAPE ACTION ThisWindow.Release   
      
      DEFINE MAIN MENU
         DEFINE POPUP "File"
            MENUITEM "Save" ACTION SaveImage()
         END POPUP
      END MENU
      
   END WINDOW

   CENTER WINDOW Win1
   ACTIVATE WINDOW Win1
    
RETURN Nil

*-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.

PROCEDURE Proc_ON_INIT
  hBitmap := BT_BitmapLoadFile( "imagen.JPG" )
RETURN

*-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.

PROCEDURE Proc_ON_RELEASE
   BT_BitmapRelease( hBitmap )
RETURN

*-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.

PROCEDURE Proc_ON_PAINT

LOCAL hDC, BTstruct
   hDC := BT_CreateDC ("Win1", BT_HDC_INVALIDCLIENTAREA, @BTstruct)
      BT_DrawBitmap (hDC, 0, 0, 740, 440, BT_COPY, hBitmap)
      BT_DrawEllipse (hDC, 140, 200, 400, 230, GREEN, 2)
   BT_DeleteDC (BTstruct)
   
RETURN

*-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.

PROCEDURE SaveImage()

   LOCAL hBitmap := BT_BitmapCaptureClientArea("Win1",0,0,760,480),;
         cImgFNam2 :=  "SaveImage.jpg" 
   
   BT_BitmapSaveFile( hBitmap, cImgFNam2, 2 )     
   
   MsgInfo( "saved" )
   
RETURN

*-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.
   
